/*

 methods_4
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

//
//-------------------------------------------
//                   XY-WING
//-------------------------------------------
//
int VerificaXYWing (int Row,int Col,int Col1)
{
	int y,x,b,p;
	int test;
	int xy,yz,xz;
	test=(SUD_BUF[Row][Col] & SUD_BUF[Row][Col1]);
	UnsetFlagCandidato (&test, CANDI_MSK);


	// Verifica 1 solo candidato in comune
	if (ContaBits(test)!=1) return 0;


	xy=SUD_BUF[Row][Col];  //UnsetFlagCandidato (&xy, CANDI_MSK);
	yz=SUD_BUF[Row][Col1]; //UnsetFlagCandidato (&yz, CANDI_MSK);
	xz=(xy|yz);          UnsetFlagCandidato (&xz, test);

	//printf ("Row=%d x=%d x1=%d ",Row+1,Col+1,Col1+1);
	//printf ("xy=%d yz=%d xz=%d\n",xy,yz,xz);


	for (y=0;y<SUD_TAB;y++)
	{
		if (SUD_BUF[y][Col]==xz)
		{
			sprintf (BUFF,
			gettext("Found R%dC%d R%dC%d R%dC%d"),
			Row+1,Col+1,Row+1,Col1+1,y+1,Col+1);

			AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);			
			//printf ("**Trovato in y=%d x=%d\n",y+1,Col+1);
		}
		if (SUD_BUF[y][Col1]==xz)
		{
			sprintf (BUFF,
			gettext("Found R%dC%d R%dC%d R%dC%d"),
			Row+1,Col+1,Row+1,Col1+1,y+1,Col1+1);

			AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);			
			//printf ("**Trovato in y=%d x=%d\n",y+1,Col1+1);
		}
		
	}

	Coordinateyx2Blocco (Row,Col,&b,&p);
	for (p=0;p<SUD_TAB;p++)
	{
		CoordinateBlocco2yx (b,p,&y,&x);
		if (SUD_BUF[y][x]==xz && y!=Row)
		{
			sprintf (BUFF,
			gettext("Found R%dC%d R%dC%d R%dC%d"),
			Row+1,Col+1,Row+1,Col1+1,y+1,x+1);

			AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
			//printf ("**Trovato in y=%d x=%d\n",y+1,x+1);
		}
	}

	Coordinateyx2Blocco (Row,Col1,&b,&p);
	for (p=0;p<SUD_TAB;p++)
	{
		CoordinateBlocco2yx (b,p,&y,&x);
		if (SUD_BUF[y][x]==xz && y!=Row)
		{
			sprintf (BUFF,
			gettext("Found R%dC%d R%dC%d R%dC%d"),
			Row+1,Col+1,Row+1,Col1+1,y+1,x+1);

			AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
			//printf ("**Trovato in y=%d x=%d\n",y+1,x+1);
		}
	}

	return (0);

	
}
/*
*/
int XYWingRighe()
{
	int y,x,x1;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (ContaBits(SUD_BUF[y][x])==2)
			{
				for (x1=x+1;x1<SUD_TAB;x1++)
				{
					if (ContaBits(SUD_BUF[y][x1])==2)
						VerificaXYWing (y,x,x1);
				}
			}
		}
	}

	return (0);
}

int XYWing()
{
	Clear_Comments ();
	AddItemListCmd (ViewComment, LABEL,
		gettext("XY-WING") , NULL);

	XYWingRighe();
	//XYWingColonne();

	SudoFinish(1);

	return (0);
}
